#include <stdlib.h>
#include "theta.h"
#include "tNear.h"
#include <string>
#include <vector>
#include <algorithm>
#include <iostream>

using namespace std;

bool not_space( char c) { return !isspace( c ); }

int main (int argv, char **argc)
{
   typedef CThetaMatch<string> CTM;
   CTM ctm( 256 );
   ctm.m_fnSetVowelsDown( );

   CNearTree<string, CTM> Tree;
   // ctm.SetThetaWeights ( 10.0, 8.0 );
   vector< string > vStringList;

   string sInput;
   while ( cin >> sInput )
   {
      // vStringList.push_back( sInput );
      Tree.m_fnInsert( sInput, ctm );
      // cout << sInput << endl;
   }
   // cout << "words read = " << vStringList.size( ) << endl;

   double dwc = 0.4;


   vector< string > vBadText;
   string sBadTextString = "yo caint alwys ge wha yu wan ou cnt alwis gt wat oyu wnt";
   string::iterator ist = sBadTextString.begin( );
   while ( ist != sBadTextString.end( ) )
   {
      ist = find_if( ist, sBadTextString.end( ), not_space );
      string::iterator inext = find_if( ist, sBadTextString.end( ), isspace );
      if ( ist != sBadTextString.end( ) )
         vBadText.push_back( string( ist, inext ));
      ist = inext;
   }

   cout << "Bad text string = " << sBadTextString << endl;

   string s;
   vector<string>::iterator iv;

   string result;

   // ctm.set_ThetaCompensation( dwc );
   for ( iv=vBadText.begin( ); iv<vBadText.end( ); ++iv )
   {
      if ( Tree.m_bfnNearestNeighbor ( ctm, 1000.0, result, *iv ) )
         cout << result << " ";
      else
         cout << "null for " << *iv << endl;
   }
   cout << endl;


   vector< string > vResult;
   double dRadius;
   vector<string>::iterator is;
   for ( iv=vBadText.begin( ); iv<vBadText.end( ); ++iv )
   {
      if ( Tree.m_bfnNearestNeighbor ( ctm, 1000.0, result, *iv ) )
      {
//    long m_lfnFindInSphere ( const double& dRadius,  std::vector<  T >& tClosest,   const T& t ) const
         dRadius = ctm.theta( result, *iv );
         cout << *iv ;
         long nFound = Tree.m_lfnFindInSphere ( ctm, max(1.3 * dRadius, .2), vResult, *iv );
         for ( is=vResult.begin( ); is<vResult.end( ); ++is )
         {
            cout << "\t\t" << *is << endl;
         }
      }
      else
         cout << "null for " << *iv << endl;
   }
   cout << endl;


      dwc = 0.0;

   return (EXIT_SUCCESS);
}