#include <stdlib.h>
#include "theta.h"
#include <string>
#include <vector>
#include <algorithm>
#include <iostream>

using namespace std;

   typedef pair< double, string > pItem;

bool not_space( char c) { return !isspace( c ); }


void UseDefaultString ( CThetaMatch< string >&   ctm, const string& sBadTextString, vector< pItem >& vBadText )
{
   string::const_iterator ist;
   ist = sBadTextString.begin( );
   pItem pI;
   while ( ist != (string::const_iterator)sBadTextString.end( ) )
   {
      ist = find_if( ist, sBadTextString.end( ), not_space );
      string::const_iterator inext = find_if( ist, sBadTextString.end( ), isspace );
      if ( ist != sBadTextString.end( ) )
      {
         pI.second =  string( ist, inext );
         vBadText.push_back( pI );
      }
      ist = inext;
   }

   if ( ! vBadText.empty( ) )
   {
      vector< pItem >::iterator iv = vBadText.begin( );
      const string s1 = (*iv).second;
      for ( iv=vBadText.begin( ); iv<vBadText.end( ); ++iv )
      {
         (*iv).first = ctm.theta ( (*iv).second, s1 );
      }
   }
}

int main (int argv, char **argc)

{
   const string sDefaultString = "xxx xxy xyx yxx xyy yxy yyx yyy xxxx xx";
   CThetaMatch< string >  ctm;
   ctm.m_fnSetVowelsDown( );
   // ctm.SetThetaWeights( 1.0, 1.0 );

   string sInput;
   vector< string > vStringList;
   vector< pItem > pL;
   pItem pTemp;
   string sFirstInput;
   while ( cin >> sInput )
   {
      if ( pL.empty( ) ) sFirstInput = sInput;
      pTemp.first = ctm.theta ( sInput, sFirstInput );
      pTemp.second = sInput;
      pL.push_back( pTemp );
   }
   if ( pL.empty( ) )
      UseDefaultString ( ctm, sDefaultString, pL );

   sort( pL.begin( ), pL.end( ) );

/*
   vector<string>::iterator iv;
   for ( iv=vStringList.begin( ); iv<vStringList.end( ); ++iv )
      cout 
         << "sFirstInput \"" 
         << sFirstInput 
         << "\"  \"" 
         << *iv 
         << "\" \t " 
         << ctm.theta( sFirstInput, *iv ) 
         << endl;
*/

   vector<pItem>::iterator ip;
   for ( ip=pL.begin( ); ip<pL.end( ); ++ip )
   {
      cout 
         << "\""
         << (*ip).second
         << "\" \t " 
         << (*ip).first
         << endl;
   }

   return (EXIT_SUCCESS);
}