//
//  gabsgenome.h - bit string genome representation, operators

#ifndef GABSGENOME_H
#define GABSGENOME_H
#include "gaimport.h"
#include "gagenome.h"


class GA_API GABitStringGenome:public GAGenome
{
public :
	GABitStringGenome(int size=0);
	virtual ~GABitStringGenome();
	GABitStringGenome(const GABitStringGenome &src)  {*this =  src;};
	GABitStringGenome& operator = (const GABitStringGenome& rhs);
	//
	// Initialization.
	void				SetSize(int size);
	void				Randomize();
	//
	//  Simple bit string operations.
	void				Clear()     ;
	void				Clear(int bit);
	void				Clear(int startBit, int length);
	void				Set()     ;
	void				Set(int bit);
	void				Set(int startBit, int length);
	bool				IsSet(int i);   
	//
	// Genetic operations.
	virtual void	Initialize(){Randomize();};
	virtual void	Mutate( double mfactor);
	virtual void	CrossOver( GAGenome* genome);

protected:
	BYTE*				m_bits;
	int				m_size;

};

#endif
