//
//  ksgenome.cpp - 0-1 knapsack genome
//  derived from bit string genome represents
//  solution to knapsack  problem.
#include "stdafx.h"
#include "ksgenome.h"


// size of bit string is m_maxItems
void		KSGenome::Initialize()
{
	SetSize(m_maxItems);
	Randomize();
}

// Evaluate function adds up the 
// profit for all the included items
// and subtracts the penalty function
// if it exceeds the capacity constraint.
double	KSGenome::Evaluate()
{
	double ret = 0;
	double totalWgt = 0;
	for (int i=0;i<m_maxItems;i++)
	{
		if (IsSet(i))
		{
			ret += m_profit[i];
			totalWgt += m_weight[i];
		}
	}
	if (totalWgt > m_maxCapacity)
	{
		ret -= m_penalty*(totalWgt - m_maxCapacity);
	}
	return ret;
}

