// ksuiDlg.cpp : implementation file
//

#include "stdafx.h"
#include "comdef.h"			//You need this to get the compiler COM support
#include "ksui.h"
#include "ksuiDlg.h"
#include "..\ksgasolve\ksgasolve.h"
_COM_SMARTPTR_TYPEDEF(IKnapSackGASolver,__uuidof(IKnapSackGASolver));
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKsuiDlg dialog

CKsuiDlg::CKsuiDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CKsuiDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CKsuiDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CKsuiDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CKsuiDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CKsuiDlg, CDialog)
	//{{AFX_MSG_MAP(CKsuiDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_REGENERATE, OnRegenerate)
	ON_BN_CLICKED(IDC_INCLUDE_SELECTED, OnIncludeSelected)
	ON_BN_CLICKED(IDC_EXCLUDE_SELECTED, OnExcludeSelected)
	ON_BN_CLICKED(IDC_INCLUDE_ALL, OnIncludeAll)
	ON_BN_CLICKED(IDC_EXCLUDE_ALL, OnExcludeAll)
	ON_LBN_DBLCLK(IDC_POSSIBLE_ITEMS, OnDblclkPossibleItems)
	ON_LBN_DBLCLK(IDC_INCLUDED_ITEMS, OnDblclkIncludedItems)
	ON_BN_CLICKED(IDC_SOLVE, OnSolve)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKsuiDlg message handlers

BOOL CKsuiDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	RefreshParameterControls();
	RefreshItemList();
	RefreshResultsControls();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CKsuiDlg::RefreshParameterControls()
{
	CEdit* pEd = (CEdit*)GetDlgItem(IDC_NUM_ITEMS);
	CString cstr;
	cstr.Format("%d", m_knapSack.m_numItems);
	pEd->SetWindowText(cstr);

	pEd = (CEdit*)GetDlgItem(IDC_TOTAL_WEIGHT_CAPACITY);
	cstr.Format("%d", (int)m_knapSack.m_maxWeight);
	pEd->SetWindowText(cstr);

	pEd = (CEdit*)GetDlgItem(IDC_WEIGHT_PER_ITEM);
	cstr.Format("%d", (int)m_knapSack.m_avgWeightPerItem);
	pEd->SetWindowText(cstr);

	pEd = (CEdit*)GetDlgItem(IDC_WEIGHT_VARIANCE);
	cstr.Format("%d", (int)m_knapSack.m_weightVariance);
	pEd->SetWindowText(cstr);

	pEd = (CEdit*)GetDlgItem(IDC_PROFIT_PER_ITEM);
	cstr.Format("%d", (int)m_knapSack.m_avgProfitPerItem);
	pEd->SetWindowText(cstr);

	pEd = (CEdit*)GetDlgItem(IDC_PROFIT_VARIANCE);
	cstr.Format("%d", (int)m_knapSack.m_profitVariance);
	pEd->SetWindowText(cstr);
}

void CKsuiDlg::RefreshItemList()
{

	CListBox* pLb = (CListBox *)GetDlgItem(IDC_POSSIBLE_ITEMS);
	while (pLb->GetCount() > 0)
	{
		int i = pLb->GetCount() - 1;
		pLb->DeleteString( i);
	}
	for (int i=0;i<m_knapSack.m_numItems;i++)
	{
		CString cstr;
		cstr.Format("%2d                 %3d                %3d", i,  (int)m_knapSack.m_item[i].m_weight, (int)m_knapSack.m_item[i].m_profit);
		pLb->AddString( cstr);
	}
}

void CKsuiDlg::RefreshResultsControls()
{

	CListBox* pLb = (CListBox *)GetDlgItem(IDC_INCLUDED_ITEMS);
	while (pLb->GetCount() > 0)
	{
		int i = pLb->GetCount() - 1;
		pLb->DeleteString( i);
	}
	for (int i=0;i<m_knapSack.m_numItems;i++)
	{
		if (m_knapSack.m_item[i].m_isIncluded)
		{
			CString cstr;
			cstr.Format("%2d                 %3d                %3d", i,  (int)m_knapSack.m_item[i].m_weight, (int)m_knapSack.m_item[i].m_profit);
			pLb->AddString( cstr);
		}
	}
	int nItems;
	double totalWeight;
	double totalProfit;
	m_knapSack.GetTotals( nItems, totalProfit, totalWeight);
	CString cstr;
	cstr.Format("%d", nItems);
	CStatic* pStat = (CStatic *)GetDlgItem( IDC_TOTAL_ITEMS);
	pStat->SetWindowText(cstr);
	cstr.Format("%d", (int)totalProfit);
	pStat = (CStatic *)GetDlgItem( IDC_TOTAL_PROFIT);
	pStat->SetWindowText(cstr);
	cstr.Format("%d", (int)totalWeight);
	pStat = (CStatic *)GetDlgItem( IDC_TOTAL_WEIGHT);
	pStat->SetWindowText(cstr);

}

void CKsuiDlg::RefreshKnapsack()
{
	CString cstr;
	CEdit* pEd = (CEdit*)GetDlgItem(IDC_NUM_ITEMS);
	pEd->GetWindowText( cstr);
	m_knapSack.m_numItems = atoi( cstr);

	pEd = (CEdit*)GetDlgItem(IDC_TOTAL_WEIGHT_CAPACITY);
	pEd->GetWindowText( cstr);
	m_knapSack.m_maxWeight = atoi( cstr);

	pEd = (CEdit*)GetDlgItem(IDC_WEIGHT_PER_ITEM);
	pEd->GetWindowText( cstr);
	m_knapSack.m_avgWeightPerItem = atoi( cstr);

	pEd = (CEdit*)GetDlgItem(IDC_WEIGHT_VARIANCE);
	pEd->GetWindowText( cstr);
	m_knapSack.m_weightVariance = atoi( cstr);

	pEd = (CEdit*)GetDlgItem(IDC_PROFIT_PER_ITEM);
	pEd->GetWindowText( cstr);
	m_knapSack.m_avgProfitPerItem = atoi( cstr);

	pEd = (CEdit*)GetDlgItem(IDC_PROFIT_VARIANCE);
	pEd->GetWindowText( cstr);
	m_knapSack.m_profitVariance = atoi( cstr);
}

void CKsuiDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CKsuiDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CKsuiDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CKsuiDlg::OnRegenerate() 
{
	RefreshKnapsack();
	m_knapSack.Regenerate();
	RefreshItemList();
	RefreshResultsControls();
}

void CKsuiDlg::OnIncludeSelected() 
{
	CListBox* pLb = (CListBox *)GetDlgItem(IDC_POSSIBLE_ITEMS);
	int sel = pLb->GetCurSel();
	if (sel != LB_ERR)
	{
		m_knapSack.m_item[sel].m_isIncluded = true;
	}
	RefreshResultsControls();
	
}

void CKsuiDlg::OnExcludeSelected() 
{
	CListBox* pLb = (CListBox *)GetDlgItem(IDC_INCLUDED_ITEMS);
	int sel = pLb->GetCurSel();
	if (sel != LB_ERR)
	{
		int idx =0;
		for (int i=0;i<m_knapSack.m_numItems;i++)
		{
			if (m_knapSack.m_item[i].m_isIncluded == true)
			{
				if (idx == sel)
				{
					m_knapSack.m_item[i].m_isIncluded = false;
					break;
				}
				else
					idx++;
			}
		}
	}
	RefreshResultsControls();
}

void CKsuiDlg::OnIncludeAll() 
{
	for (int i=0;i<m_knapSack.m_numItems;i++)
	{
		m_knapSack.m_item[i].m_isIncluded = true;
	}
	RefreshResultsControls();
}

void CKsuiDlg::OnExcludeAll() 
{
	for (int i=0;i<m_knapSack.m_numItems;i++)
	{
		m_knapSack.m_item[i].m_isIncluded = false;
	}
	RefreshResultsControls();
}

void CKsuiDlg::OnDblclkPossibleItems() 
{
	OnIncludeSelected();
}

void CKsuiDlg::OnDblclkIncludedItems() 
{
	OnExcludeSelected();	
	
}

void CKsuiDlg::OnSolve() 
{
	CoInitialize(NULL);
	IKnapSackGASolverPtr pSolver = NULL ;
	HRESULT hr = pSolver.CreateInstance(__uuidof(KnapSackGASolver));
	if (FAILED(hr))
	{
		AfxMessageBox(IDS_ERROR_CREATING_KNAPSACK_SOLVER_OBJECT);
		return;
	}
	int nItems = m_knapSack.m_numItems;
	double *weights = (double *)CoTaskMemAlloc(nItems*sizeof(double));
	double *profits = (double *)CoTaskMemAlloc(nItems*sizeof(double));
	BOOL *isIncluded;
	double totalProfit;
	for (int i=0;i<nItems;i++)
	{
		weights[i] = m_knapSack.m_item[i].m_weight;
		profits[i] = m_knapSack.m_item[i].m_profit;
	}
	double maxWeight = m_knapSack.m_maxWeight;
	hr = pSolver->Solve( &nItems, profits, weights, maxWeight, &isIncluded, &totalProfit);
	for (i=0;i<nItems;i++)
	{
		if (isIncluded[i])
			m_knapSack.m_item[i].m_isIncluded = true;
		else
			m_knapSack.m_item[i].m_isIncluded = false;
	}
	CoTaskMemFree( weights);
	CoTaskMemFree( profits);
	CoTaskMemFree( isIncluded);
	RefreshResultsControls();
}
